
from functools import lru_cache
from y.contracts import Contract, has_methods
from ypricemagic import magic
from ypricemagic.utils.multicall import fetch_multicall


@lru_cache
def is_mstable_feeder_pool(address: str) -> bool:
    return has_methods(address, ['getPrice()((uint,uint))','mAsset()(address)'])

def get_price(address, block=None):
    contract = Contract(address)
    ratio, masset, decimals = fetch_multicall([contract,'getPrice'],[contract,'mAsset'],[contract,'decimals'],block=block)
    ratio = ratio[0] / 10 ** decimals
    underlying_price = magic.get_price(masset,block)
    return underlying_price * ratio
